#include <bits/stdc++.h>

using namespace std;

struct ABGrupa {
    string grupe;
    int koliko;
    int i;
};
vector<ABGrupa> pacijentiAB;


int main()
{
    int n, nulta, prva, druga, zajedno;
    string grupe;
    int koliko;

    cin >> n;
    int  A[n][4];
    for (int i = 0; i < n; ++i)
        for (int j = 0; j < 4; ++j) A[i][j] = 0;

    int k=n;
    // prva = a, druga = b, zajedno = ab
    cin >> nulta >> prva >> druga >> zajedno;

    int rez = 0;

    for(int i = 0; i < k; i++)
    {
        cin >> grupe;
        cin >> koliko;
        if(grupe == "O"){
            if(nulta < 0){
                cout << "nemoguce";
                return 0;}}
        if(grupe == "A"){
            if((nulta+prva)<koliko){
                cout << "nemoguce";
                return 0;}}
        if(grupe == "B"){
            if((nulta+druga)<koliko){
                cout << "nemoguce";
                return 0;}}

        if(grupe == "AB"){
            if((nulta+prva+druga+zajedno) < koliko){
                cout << "nemoguce";
                return 0;}}

        if(grupe == "O")
        {
            A[i][0] = koliko;
            A[i][1] = 0;
            A[i][2] = 0;
            A[i][3] = 0;
            nulta = nulta - koliko; continue;
        }
        if(grupe == "A")
        {
            if(prva >= koliko){
               // cout << "0 " << koliko << " 0 0" << endl;
               A[i][0] = 0;
               A[i][1] = koliko;
               A[i][2] = 0;
               A[i][3] = 0;
               prva = prva - koliko;}
            else{
                //cout << koliko - prva << " " << prva << " 0 0" << endl;
                A[i][0] = koliko-prva;
                A[i][1] = prva;
                A[i][2] = 0;
                A[i][3] = 0;
                nulta = nulta + prva - koliko;}continue;
        }
        if(grupe == "B")
        {
            if(druga >= koliko){
                // cout << "0 0 " << koliko << " 0" << endl;
                A[i][0] = 0;
                A[i][1] = 0;
                A[i][2] = koliko;
                A[i][3] = 0;
                druga = druga - koliko;}
            else{
                //cout << "0 " << koliko - druga << " " << druga << " 0" << endl;
                A[i][0] = 0;
                A[i][1] = koliko - druga;
                A[i][2] = druga;
                A[i][3] = 0;
                nulta = nulta + druga - koliko;}continue;
        }

        if (grupe == "AB") {
            pacijentiAB.push_back({grupe, koliko, i});
        }
    }


    for (auto p : pacijentiAB) {
        int i = p.i;
        if(p.grupe == "AB"){

        if((nulta+prva+druga+zajedno) < p.koliko){
                cout << "nemoguce";
                return 0;}}
        if(p.grupe == "AB")
        {
            if(zajedno >= p.koliko){
               A[i][0] = 0;
               A[i][1] = 0;
               A[i][2] = 0;
               A[i][3] = p.koliko;}
            else{
                if(nulta + zajedno >= p.koliko){

                   // cout << koliko - zajedno << " 0 0 " << zajedno;
                   A[i][0] = p.koliko - zajedno;
                   A[i][1] = 0;
                   A[i][2] = 0;
                   A[i][3] = zajedno;
                   nulta = nulta + zajedno - p.koliko;
                   }
                else if(nulta + prva + zajedno >= koliko){

                    //cout << nulta << " " << koliko - zajedno - nulta << " 0 " << zajedno;
                    A[i][0] = nulta;
                    A[i][1] = p.koliko - zajedno - nulta;
                    A[i][2] = 0;
                    A[i][3] = zajedno;
                    nulta = nulta + prva + zajedno - p.koliko;}
                else{
                    //cout << nulta << " " << prva << " " << koliko - zajedno - nulta - prva << " " << zajedno;
                    A[i][0] = nulta;
                    A[i][1] = prva;
                    A[i][2] = p.koliko - zajedno - nulta - prva;
                    A[i][3] = zajedno;
                    nulta = nulta + prva + druga + zajedno - p.koliko;}}
        }
    }


    cout << "moguce" << endl;
    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < 4; j++)
        {
            cout << A[i][j]<< " ";
        }
        cout << endl;
    }
    return 0;
}